//+------------------------------------------------------------------+
//|                                                        Setka.mq5 |
//|                                          Copyright  .. |
//|                           https://login.mql5.com/ru/users/Prival |
//+------------------------------------------------------------------+
#property copyright " .."
#property link      "https://login.mql5.com/ru/users/Prival"
#property version   "3.08"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//--- input parameters
input int Step=250;              //      
input int Figure=1000;           //  
input int MaxBars=0;             //   (0 -  )

                                 //   
color    new_hour   =DimGray;    //  
color    new_day    =Blue;       //  
color    new_week   =DeepPink;   //  
color    new_mon    =Yellow;     //  

                                 //   
color    new_Hfigure=RoyalBlue;  //  
color    new_Hline  =DimGray;    //  

datetime old_Times[21]={0};      //      
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
bool CheckOtherTimeFrames(string symbol)
  {
   datetime ctm[1];
   datetime checktime=TimeCurrent()-86400*60;  // 2  
   bool     res=true;
//---      "" 
   if(CopyTime(symbol,PERIOD_H1 ,checktime,1,ctm)!=1) res=false;
   if(CopyTime(symbol,PERIOD_D1 ,checktime,1,ctm)!=1) res=false;
   if(CopyTime(symbol,PERIOD_W1 ,checktime,1,ctm)!=1) res=false;
   if(CopyTime(symbol,PERIOD_MN1,checktime,1,ctm)!=1) res=false;
//---  
   return(res);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---            
   CheckOtherTimeFrames(_Symbol);
//--- indicator buffers mapping
   EventSetTimer(25);
//---
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//  EventKillTimer();
   ObjectsDeleteAll(0,0,OBJ_HLINE);   //    
   ObjectsDeleteAll(0,0,OBJ_VLINE);   //    
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate (const int rates_total,      //   
                 const int prev_calculated,  //     
                 const datetime& time[],     // Time
                 const double& open[],       // Open
                 const double& high[],       // High
                 const double& low[],        // Low
                 const double& close[],      // Close
                 const long& tick_volume[],  // Tick Volume
                 const long& volume[],       // Real Volume
                 const int& spread[])        // Spread
  {
   MqlDateTime str;
   string      line_name="";     //  
   int         line_counter=0;   //  
   int         start_pos=0;      //   
   uint        start_time=GetTickCount();

//---      
   if(rates_total<0) return(0);
   if(!CheckOtherTimeFrames(_Symbol))
     {
      Print("Other timeframes are not ready...");
      return(prev_calculated);
     }
//---   
   if(prev_calculated==0)
     {
      start_time=GetTickCount();       // 
      ObjectsDeleteAll(0,0,OBJ_VLINE); //    
      ObjectsDeleteAll(0,0,OBJ_HLINE); //    
      Ris_H_Line();                    //   
      ArrayInitialize(old_Times,0);    //  
                                       //  
      if(MaxBars!=0) if(MaxBars<rates_total) start_pos=rates_total-MaxBars;
     }
   else start_pos=prev_calculated-1;
//---   
   for(int i=start_pos;i<rates_total;i++)
     {
      color line_color=0;
      //---    
      if(_Period<PERIOD_H1) if(isNewBar_i(time[i],PERIOD_H1) && _Period<PERIOD_M30) line_color=new_hour;
      if(_Period<PERIOD_D1) if(isNewBar_i(time[i],PERIOD_D1) && _Period<PERIOD_H4 ) line_color=new_day;
      if(_Period<PERIOD_W1) if(isNewBar_i(time[i],PERIOD_W1) && _Period<PERIOD_D1 ) line_color=new_week;
      if(_Period<PERIOD_MN1)if(isNewBar_i(time[i],PERIOD_MN1)&& _Period<PERIOD_MN1) line_color=new_mon;
      //---
      if(line_color!=0)
        {
         //---    12:00
         line_counter++;
         TimeToStruct(time[i],str);
         StringConcatenate(line_name,IntegerToString(str.hour,2,'0'),":",IntegerToString(str.min,2,'0'),"_N",line_counter);
         //---  
         SetVLine(line_name,time[i],line_color);
        }
     }
//---  
   if(_Period<PERIOD_M30)
     {
      //     
      if(ObjectFind(0,"VLine_0")>=0) ObjectDelete(0,"VLine_0");
      //---     
      TimeToStruct(time[rates_total-1],str);
      SetVLine("VLine_0",time[rates_total-1]+60*(60-str.min),new_hour);
     }
//---  
   if(prev_calculated==0) 
     {
      Print("    Time=",DoubleToString((GetTickCount()-start_time)/1000.0,1),"sec for ",rates_total,
            " bars  ObjectsTotal=",ObjectsTotal(0,0,-1)," MaxBars=",MaxBars);
     }
   return(rates_total);
  }
//+----------------------------------------------------------------------------+
//|   :   OBJ_VLINE                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    nm -                                                            |
//|    t1 -                                                               |
//|    cl -                                                           |
//+----------------------------------------------------------------------------+
void SetVLine(string nm,datetime t1,color cl=Red)
  {
//---    
   if(t1<=0) return;
//---  ,    
   if(ObjectFind(0,nm)<0) ObjectCreate(0,nm,OBJ_VLINE,0,t1,2);
//---   
   ObjectSetInteger(0,nm,OBJPROP_COLOR,cl);
   ObjectSetInteger(0,nm,OBJPROP_STYLE,STYLE_DOT);
   ObjectSetInteger(0,nm,OBJPROP_WIDTH,     1);          //    
   ObjectSetInteger(0,nm,OBJPROP_BACK,      true);       //   
   ObjectSetInteger(0,nm,OBJPROP_SELECTABLE,false);      //     
  }
//+----------------------------------------------------------------------------+
//|   :   OBJ_HLINE                 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    nm -                                                            |
//|    p1 -                                                      |
//|    cl -                                                           |
//+----------------------------------------------------------------------------+
void SetHLine(string nm,double p1,color cl=Red)
  {
//---  ,    
   if(ObjectFind(0,nm)<0) ObjectCreate(0,nm,OBJ_HLINE,0,0,p1);
//---   
   ObjectSetInteger(0,nm,OBJPROP_COLOR,     cl);         //   
   ObjectSetInteger(0,nm,OBJPROP_STYLE,     STYLE_DOT);  // 
   ObjectSetInteger(0,nm,OBJPROP_WIDTH,     1);          //    
   ObjectSetInteger(0,nm,OBJPROP_SELECTABLE,false);      //    
  }
//+----------------------------------------------------------------------------+
//|   :                                    |
//+----------------------------------------------------------------------------+
void Ris_H_Line()
  {
   double Uroven=0.0;      //    
   int    rez,             //    
   line_counter=0,         //  
   i=0;                    //  

                           //  max  min  
   double mass[],
   max=10,
   min= 0;
   int    index;

   ArraySetAsSeries(mass,true);

   if(CopyHigh(_Symbol,PERIOD_MN1,0,Bars(_Symbol,PERIOD_MN1),mass)>2)
     {
      index=ArrayMaximum(mass,0,WHOLE_ARRAY);
      CopyHigh(_Symbol,PERIOD_MN1,index,1,mass);
      max=mass[0];
     }
   if(CopyLow(_Symbol,PERIOD_MN1,0,Bars(_Symbol,PERIOD_MN1),mass)>2)
     {
      index=ArrayMinimum(mass,0,WHOLE_ARRAY);
      CopyLow(_Symbol,PERIOD_MN1,index,1,mass);
      min=mass[0];
     }
//  
   while(Uroven<=max)
     {
      i++;
      Uroven=i*Step*_Point;
      if(Uroven>=min)
        {
         line_counter++;
         rez=(int)MathMod(Uroven*MathPow(10,_Digits),Figure); //   
         if(rez==0)
           {
            //     W1
            if(_Period<PERIOD_W1) SetHLine("HLine_"+string(line_counter),Uroven,new_Hfigure);
           }
         else
         //     M30 
            if(_Period<PERIOD_M30) SetHLine("HLine_"+string(line_counter),Uroven,new_Hline);
        }// end if(Uroven>=Min)
     }// end while (Uroven<=Max)
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|  true   ,  false                      |
//+------------------------------------------------------------------+
bool isNewBar_i(datetime date,ENUM_TIMEFRAMES timeFrame)
  {
   bool     res=false;           //     
   int      pos=0;               //    old_Times[]     
   datetime new_Time[1];         //   
//---
   switch(timeFrame)
     {
      case PERIOD_M1:  pos= 0; break;
      case PERIOD_M2:  pos= 1; break;
      case PERIOD_M3:  pos= 2; break;
      case PERIOD_M4:  pos= 3; break;
      case PERIOD_M5:  pos= 4; break;
      case PERIOD_M6:  pos= 5; break;
      case PERIOD_M10: pos= 6; break;
      case PERIOD_M12: pos= 7; break;
      case PERIOD_M15: pos= 8; break;
      case PERIOD_M20: pos= 9; break;
      case PERIOD_M30: pos=10; break;
      case PERIOD_H1:  pos=11; break;
      case PERIOD_H2:  pos=12; break;
      case PERIOD_H3:  pos=13; break;
      case PERIOD_H4:  pos=14; break;
      case PERIOD_H6:  pos=15; break;
      case PERIOD_H8:  pos=16; break;
      case PERIOD_H12: pos=17; break;
      case PERIOD_D1:  pos=18; break;
      case PERIOD_W1:  pos=19; break;
      case PERIOD_MN1: pos=20; break;
     }
//---         new_Time[0]   
   if(CopyTime(_Symbol,timeFrame,date,1,new_Time)==1)
     {
      if(old_Times[pos]!=new_Time[0]) //       
        {
         if(old_Times[pos]!=0) res=true;    //     ,   =  
         old_Times[pos]=new_Time[0];        //   
        }
     }
   else
      Print("Timeframe ",fTimeFrameName(timeFrame)," is not ready");
//---- 
   return(res);
  }
//+---------------------------------------------------------------------------------------------+
string fTimeFrameName(int arg)
  {
   int v;
   if(arg==0)
     {
      v=_Period;
     }
   else
     {
      v=arg;
     }
   switch(v)
     {
      case PERIOD_M1:    return("M1");
      case PERIOD_M2:    return("M2");
      case PERIOD_M3:    return("M3");
      case PERIOD_M4:    return("M4");
      case PERIOD_M5:    return("5");
      case PERIOD_M6:    return("6");
      case PERIOD_M10:   return("M10");
      case PERIOD_M12:   return("M12");
      case PERIOD_M15:   return("M15");
      case PERIOD_M20:   return("M20");
      case PERIOD_M30:   return("M30");
      case PERIOD_H1:    return("H1");
      case PERIOD_H2:    return("H2");
      case PERIOD_H3:    return("H3");
      case PERIOD_H4:    return("H4");
      case PERIOD_H6:    return("H6");
      case PERIOD_H8:    return("H8");
      case PERIOD_H12:   return("H12");
      case PERIOD_D1:    return("D1");
      case PERIOD_W1:    return("W1");
      case PERIOD_MN1:   return("MN1");
      default:    return("?");
     }
  } // end fTimeFrameName
